package org.bergnet.test.webid.publishers;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.net.URL;

import org.bergnet.test.webid.WebIDTestException;
import org.bergnet.test.webid.WebIDTests;


public class FileFOAFPublisher implements FOAFPublisher {
	public static final String PROPERTY_BASE_PATH = "org.bergnet.commons.test.webid.publish.filepublisher.basePath";

	private String basePath;
	private URL baseUrl;

	public FileFOAFPublisher(WebIDTests.Config configuration) throws WebIDTestException {
		basePath = configuration.getProperties().get(PROPERTY_BASE_PATH).toString();

		if(basePath == null)
			throw new WebIDTestException("Base path not defined");

		baseUrl = configuration.getBaseUrl();
	}

	public void stop() throws WebIDTestException {
	}

	public URL getBaseUrl() {
		return baseUrl;
	}

	public void publish(String id, String foaf, String contentType) throws WebIDTestException {
		try {
			BufferedWriter writer = new BufferedWriter(new FileWriter(this.basePath + id));
			writer.write(foaf);
			writer.close();
		} catch(Exception e) {
			throw new WebIDTestException("Can't write FOAF file", e);
		}
	}
}
